﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Dim epochs As Int
	Dim learnFactor As Double
	Dim lNeurons As List
	Private cells As Int = 6
	Dim xutils As Utils

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(epoch As Int,lf As Double)
	lNeurons.Initialize
	xutils.Initialize
	
	For a = 0 To cells - 1
		Dim nN As nNeurons
		nN.Initialize
		lNeurons.Add(nN)
	Next
	epochs = epoch 
	learnFactor = lf'1.0
End Sub

Sub predict(input1 As Int, input2 As Int) As Double
	Dim brain(6) As nNeurons
	For a = 0 To 5
	brain(a) = lNeurons.Get(a)
	Next
	Return brain(5).compute(brain(4).compute(brain(2).compute(input1,input2),brain(1).compute(input1,input2)),brain(3).compute(brain(1).compute(input1,input2),brain(0).compute(input1,input2)))
End Sub

Sub train(data As List, answers As List)
	' has to be an Object so it can be nulled
	Dim bestEpochLoss As Object = Null
	
	For epoch = 0 To epochs -1
		Dim epochNeuron As nNeurons
		epochNeuron.Initialize
		epochNeuron = lNeurons.Get(epoch Mod 6).As(nNeurons)
		epochNeuron.mutate(learnFactor)
		Dim predictions As List
		predictions.Initialize
		For i = 0 To data.Size - 1
			Dim xx As info = data.Get(i)
			predictions.InsertAt(i,predict(xx.x,xx.y))
		Next
		'Log(predictions)
		Dim thisEpochLoss As Double = xutils.meanSquareLoss(answers,predictions)
		If epoch Mod 100 = 0 Then
			Log($"Epoch: ${epoch} | bestEpochLoss: ${bestEpochLoss} | thisEpochLoss: ${thisEpochLoss} "$)	
		End If
		If bestEpochLoss = Null Then
			'Log("true")
			bestEpochLoss = thisEpochLoss
			epochNeuron.remember()
		Else
			If thisEpochLoss < bestEpochLoss Then
				bestEpochLoss = thisEpochLoss
				epochNeuron.remember()
			Else
				epochNeuron.forget()		
			End If
		End If
	Next
''Double bestEpochLoss = null;
'For (int epoch = 0; epoch < epochs; epoch++){
'	// adapt neuron
'	Neuron epochNeuron = neurons.get(epoch % 6);
'	epochNeuron.mutate(this.learnFactor);
'
'	List<Double> predictions = new ArrayList<Double>();
'	For (int i = 0; i < data.size(); i++){
'	predictions.add(i, this.predict(data.get(i).get(0), data.get(i).get(1)));
'	}
'	Double thisEpochLoss = Util.meanSquareLoss(answers, predictions);
'
'	If (epoch % 10 == 0) System.out.println(String.format("Epoch: %s | bestEpochLoss: %.15f | thisEpochLoss: %.15f", epoch, bestEpochLoss, thisEpochLoss));
'
'	If (bestEpochLoss == Null){
'	bestEpochLoss = thisEpochLoss;
'	epochNeuron.remember();
'	} Else {
'	If (thisEpochLoss < bestEpochLoss){
'	bestEpochLoss = thisEpochLoss;
'	epochNeuron.remember();
'	} Else {
'	epochNeuron.forget();
'          }
'	}
'      }
'    }	
End Sub
'#if java
'  static class Network {
'    int epochs = 0; //1000;
'	Double learnFactor = null;
'    List<Neuron> neurons = Arrays.asList(
'      new Neuron(), new Neuron(), new Neuron(), 
'      new Neuron(), new Neuron(), 
'      new Neuron());
'    
'    public Network(int epochs){
'      this.epochs = epochs;
'    }
'    public Network(int epochs, Double learnFactor) {
'      this.epochs = epochs;
'      this.learnFactor = learnFactor;
'    }
'
'    public Double predict(Integer input1, Integer input2){
'      return neurons.get(5).compute(
'        neurons.get(4).compute(
'	  neurons.get(2).compute(input1, input2),
'	  neurons.get(1).compute(input1, input2)
'	),
'	neurons.get(3).compute(
'	  neurons.get(1).compute(input1, input2),
'	  neurons.get(0).compute(input1, input2)
'	)
'      );
'    }
'    public void train(List<List<Integer>> data, List<Double> answers){
'      Double bestEpochLoss = null;
'      for (int epoch = 0; epoch < epochs; epoch++){
'        // adapt neuron
'        Neuron epochNeuron = neurons.get(epoch % 6);
'	epochNeuron.mutate(this.learnFactor);
'
'	List<Double> predictions = new ArrayList<Double>();
'	for (int i = 0; i < data.size(); i++){
'          predictions.add(i, this.predict(data.get(i).get(0), data.get(i).get(1)));
'	}
'        Double thisEpochLoss = Util.meanSquareLoss(answers, predictions);
'
'	if (epoch % 10 == 0) System.out.println(String.format("Epoch: %s | bestEpochLoss: %.15f | thisEpochLoss: %.15f", epoch, bestEpochLoss, thisEpochLoss));
'
'	if (bestEpochLoss == null){
'          bestEpochLoss = thisEpochLoss;
'	  epochNeuron.remember();
'	} else {
'	  if (thisEpochLoss < bestEpochLoss){
'	    bestEpochLoss = thisEpochLoss;
'	    epochNeuron.remember();
'	  } else {
'            epochNeuron.forget();
'          }
'	}
'      }
'    }
'  }
'
'#End If
#if java
public static void setToNull(Object o){
	o = null;
}
#End If