﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Dim oldBias, bias As Double
	Dim oldWeight1, weight1 As Double
	Dim oldWeight2, weight2 As Double
	Dim xutils As Utils
	Dim Random As JavaObject
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	xutils.Initialize
	Random.InitializeNewInstance("java.security.SecureRandom",Null)
	oldBias    = sRandom(-1,1)
	bias       = sRandom(-1,1)
	oldWeight1 = sRandom(-1,1)
	weight1    = sRandom(-1,1)
	oldWeight2 = sRandom(-1,1)
	weight2    = sRandom(-1,1)
End Sub

Sub sRandom(minV As Double, maxV As Double) As Double
	Return Random.RunMethod("nextDouble",Array(minV,maxV))
End Sub

Sub toString As String
	Return $"oldBias: ${oldBias} | bias: ${bias} | oldWeight1: ${oldWeight1} | weight1: ${weight1} | oldWeight2: ${oldWeight2} | weight2: ${weight2}"$
End Sub

Sub mutate(lF As String)
	Dim learnFactor As Object = lF
	Dim propertyToChange As Int = Random.RunMethod("nextInt",Array(0,3))
	Dim changeFactor As Double = IIf((learnFactor=Null),sRandom(-1,1),learnFactor*sRandom(-1,1))
	If propertyToChange = 0 Then
		bias = bias + changeFactor
	else if propertyToChange = 1 Then
		weight1 = weight1 + changeFactor
	Else
		weight2 = weight2 + changeFactor
	End If
End Sub

Sub compute(input1 As Double, input2 As Double) As Double
	Dim preActivation As Double  = (weight1 * input1) + (weight2 * input2) + bias
	Dim output As Double = xutils.sigmoid(preActivation)
	Return output
End Sub

Sub forget()
	bias = oldBias
	weight1 = oldWeight1
	weight2 = oldWeight2
End Sub
Sub remember()
	oldBias = bias
	oldWeight1 = weight1
	oldWeight2 = weight2
End Sub
'#if java
'  static class Neuron {
'  	
'    Random random = new Random();
'    private Double oldBias = random.nextDouble(-1, 1), bias = random.nextDouble(-1, 1); 
'    public Double oldWeight1 = random.nextDouble(-1, 1), weight1 = random.nextDouble(-1, 1); 
'    private Double oldWeight2 = random.nextDouble(-1, 1), weight2 = random.nextDouble(-1, 1);
'   
'    public String toString(){
'      return String.format("oldBias: %.15f | bias: %.15f | oldWeight1: %.15f | weight1: %.15f | oldWeight2: %.15f | weight2: %.15f", this.oldBias, this.bias, this.oldWeight1, this.weight1, this.oldWeight2, this.weight2);
'    }
'
'    public void mutate(Double learnFactor){
'      int propertyToChange = random.nextInt(0, 3);
'      Double changeFactor = (learnFactor == null) ? random.nextDouble(-1, 1) : (learnFactor * random.nextDouble(-1, 1));
'      if (propertyToChange == 0){ 
'        this.bias += changeFactor; 
'      } else if (propertyToChange == 1){ 
'	this.weight1 += changeFactor; 
'      } else { 
'	this.weight2 += changeFactor; 
'      };
'    }
'    public void forget(){
'      bias = oldBias;
'      weight1 = oldWeight1;
'      weight2 = oldWeight2;
'    }
'    public void remember(){
'      oldBias = bias;
'      oldWeight1 = weight1;
'      oldWeight2 = weight2;
'    }
'    public double compute(double input1, double input2){
'//      this.input1 = input1;  this.input2 = input2;
'      double preActivation = (this.weight1 * input1) + (this.weight2 * input2) + this.bias;
'      double output = Util.sigmoid(preActivation);
'      return output;
'    }
'  }
'
'#End If